//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A8AD2F6035D.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A8AD2F6035D.cm

//## begin module%3A8AD2F6035D.cp preserve=no
//## end module%3A8AD2F6035D.cp

//## Module: ComponentBase%3A8AD2F6035D; Package body
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/ComponentBase.cxx

//## begin module%3A8AD2F6035D.additionalIncludes preserve=no
//## end module%3A8AD2F6035D.additionalIncludes

//## begin module%3A8AD2F6035D.includes preserve=yes
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/Model/UniqueEnergy.h>
#include <XSModel/Parameter/ModParam.h>
//## end module%3A8AD2F6035D.includes

// XSModelFunction
#include <XSUtil/FunctionUtils/XSModelFunction.h>
// Parameter
#include <XSModel/Parameter/Parameter.h>
// CGroupBase
#include <XSModel/Model/Component/CGroupBase.h>
// MixBase
#include <XSModel/Model/Component/MixBase.h>
// XSutility
#include <XSUtil/Utils/XSutility.h>
// ComponentBase
#include <XSModel/Model/Component/ComponentBase.h>


//## begin module%3A8AD2F6035D.declarations preserve=no
//## end module%3A8AD2F6035D.declarations

//## begin module%3A8AD2F6035D.additionalDeclarations preserve=yes
#include "XSContainer.h"
#include "XSstreams.h"
//## end module%3A8AD2F6035D.additionalDeclarations


// Class ComponentBase::InvalidInput 

ComponentBase::InvalidInput::InvalidInput (const string& errMessage)
  //## begin ComponentBase::InvalidInput::InvalidInput%376E63DE30B0.hasinit preserve=yes
  : YellowAlert()
  //## end ComponentBase::InvalidInput::InvalidInput%376E63DE30B0.hasinit
  //## begin ComponentBase::InvalidInput::InvalidInput%376E63DE30B0.initialization preserve=yes
  //## end ComponentBase::InvalidInput::InvalidInput%376E63DE30B0.initialization
{
  //## begin ComponentBase::InvalidInput::InvalidInput%376E63DE30B0.body preserve=yes
  tcerr << errMessage << '\n';
  //## end ComponentBase::InvalidInput::InvalidInput%376E63DE30B0.body
}


// Class ComponentBase::InvalidTableModel 

ComponentBase::InvalidTableModel::InvalidTableModel()
  //## begin InvalidTableModel::InvalidTableModel%3D5AC15C030E_const.initialization preserve=yes
  //## end InvalidTableModel::InvalidTableModel%3D5AC15C030E_const.initialization
{
  //## begin ComponentBase::InvalidTableModel::InvalidTableModel%3D5AC15C030E_const.body preserve=yes
  //## end ComponentBase::InvalidTableModel::InvalidTableModel%3D5AC15C030E_const.body
}


// Class ComponentBase::NoSuchComponent 

// Class ComponentBase 

ComponentBase::ComponentBase(const ComponentBase &right)
  //## begin ComponentBase::ComponentBase%3A8AD229032B_copy.hasinit preserve=yes
      : m_name(right.m_name),
        m_index(right.m_index),
        m_maxEnergy(right.m_maxEnergy),
        m_minEnergy(right.m_minEnergy),
        m_numParams(right.m_numParams),
        m_error(right.m_error),
        m_compute(right.m_compute),
        m_fluxSaved(right.m_fluxSaved),
        m_initString(right.m_initString),
        m_isSpectrumDependency(right.m_isSpectrumDependency),
        m_parameterSet(),
        m_parent(right.m_parent),  
        m_generator(right.m_generator), // Non-owning shallow copy
        m_mixGenerator(right.m_mixGenerator),
        m_uniquePhotonArray(right.m_uniquePhotonArray),
        m_uniquePhotonErrArray(right.m_uniquePhotonErrArray),
        m_savedUniquePhotonArray(right.m_savedUniquePhotonArray)
  //## end ComponentBase::ComponentBase%3A8AD229032B_copy.hasinit
  //## begin ComponentBase::ComponentBase%3A8AD229032B_copy.initialization preserve=yes
  //## end ComponentBase::ComponentBase%3A8AD229032B_copy.initialization
{
  //## begin ComponentBase::ComponentBase%3A8AD229032B_copy.body preserve=yes
  //## end ComponentBase::ComponentBase%3A8AD229032B_copy.body
}

ComponentBase::ComponentBase (CGroupBase* p)
  //## begin ComponentBase::ComponentBase%3A9E7D2802F0.hasinit preserve=yes
      : m_name(""),
        m_index(0),
        m_maxEnergy(),
        m_minEnergy(),
        m_numParams(0),
        m_error(false),
        m_compute(true),
        m_fluxSaved(false),
        m_initString(""),
        m_isSpectrumDependency(false),
        m_parameterSet(),
        m_parent(p),
        m_generator(0),
        m_mixGenerator(0),
        m_uniquePhotonArray(),
        m_uniquePhotonErrArray(),
        m_savedUniquePhotonArray()
  //## end ComponentBase::ComponentBase%3A9E7D2802F0.hasinit
  //## begin ComponentBase::ComponentBase%3A9E7D2802F0.initialization preserve=yes
  //## end ComponentBase::ComponentBase%3A9E7D2802F0.initialization
{
  //## begin ComponentBase::ComponentBase%3A9E7D2802F0.body preserve=yes
  //## end ComponentBase::ComponentBase%3A9E7D2802F0.body
}


ComponentBase::~ComponentBase()
{
  //## begin ComponentBase::~ComponentBase%3A8AD229032B_dest.body preserve=yes
     
  if (m_mixGenerator) 
  {
     // ModelContainer has ownership of MixBase objects, so instead
     // of calling delete on m_mixGenerator, tell ModelContainer
     // to do it.
     XSContainer::models->removeMixingComponent(m_mixGenerator->name());
     m_mixGenerator = 0;
  }
  //## end ComponentBase::~ComponentBase%3A8AD229032B_dest.body
}


ComponentBase & ComponentBase::operator=(const ComponentBase &right)
{
  //## begin ComponentBase::operator=%3A8AD229032B_assign.body preserve=yes
  ComponentBase __temp(right);
  swap(__temp);
  return *this;  
  //## end ComponentBase::operator=%3A8AD229032B_assign.body
}



//## Other Operations (implementation)
void ComponentBase::swap (ComponentBase& right) throw ()
{
  //## begin ComponentBase::swap%3A8AD8070133.body preserve=yes
  std::swap(m_name,right.m_name);
  std::swap(m_index,right.m_index);
  std::swap(m_maxEnergy,right.m_maxEnergy);
  std::swap(m_minEnergy,right.m_minEnergy);
  std::swap(m_fluxSaved,right.m_fluxSaved);
  std::swap(m_numParams,right.m_numParams);
  std::swap(m_generator,right.m_generator);
  std::swap(m_mixGenerator,right.m_mixGenerator);
  std::swap(m_initString,right.m_initString);
  std::swap(m_parameterSet,right.m_parameterSet);  
  std::swap(m_parent,right.m_parent);  
  std::swap(m_error,right.m_error);   
  std::swap(m_compute,right.m_compute); 
  std::swap(m_uniquePhotonArray,right.m_uniquePhotonArray);  
  std::swap(m_uniquePhotonErrArray,right.m_uniquePhotonErrArray);
  std::swap(m_savedUniquePhotonArray,right.m_savedUniquePhotonArray);
  std::swap(m_isSpectrumDependency,right.m_isSpectrumDependency);
  //## end ComponentBase::swap%3A8AD8070133.body
}

ComponentBase* ComponentBase::clone () const
{
  //## begin ComponentBase::clone%3A8AD88202FD.body preserve=yes
  //## end ComponentBase::clone%3A8AD88202FD.body

  return new ComponentBase(*this);
}

const Parameter* ComponentBase::parameterSet (const string& name) const
{
  //## begin ComponentBase::parameterSet%3A8AE4CD034F.body preserve=yes
  const Parameter* value(0);
  XSutility::MatchPtrName<Parameter> matchName;
  std::vector<Parameter*>::const_iterator par;
  par = find_if(m_parameterSet.begin(),m_parameterSet.end(),bind2nd(matchName,name));
  if ( par != m_parameterSet.end() )  value = *par;
  return value;
  //## end ComponentBase::parameterSet%3A8AE4CD034F.body
}

Parameter* ComponentBase::parameterSet (const string& name, Parameter* value)
{
  //## begin ComponentBase::parameterSet%3A8AE4FC0227.body preserve=yes
  XSutility::MatchPtrName<Parameter> matchName;
  std::vector<Parameter*>::iterator par;
  par = find_if(m_parameterSet.begin(),m_parameterSet.end(),bind2nd(matchName,name));
  if (par != m_parameterSet.end())
  {
          std::replace(m_parameterSet.begin(),m_parameterSet.end(),*par,value);
  }
  else value = 0;
  return value;  
  //## end ComponentBase::parameterSet%3A8AE4FC0227.body
}

const string& ComponentBase::parentName () const
{
  //## begin ComponentBase::parentName%3A9E91790052.body preserve=yes
  //## end ComponentBase::parentName%3A9E91790052.body

  return m_parent->parentName();
}

size_t ComponentBase::dataGroup () const
{
  //## begin ComponentBase::dataGroup%3A9E951100F8.body preserve=yes
  //## end ComponentBase::dataGroup%3A9E951100F8.body

  return m_parent->dataGroup();
}

void ComponentBase::deleteParameters () throw ()
{
  //## begin ComponentBase::deleteParameters%3DD11CE00221.body preserve=yes
  // delete & dereference don't throw.  
  // since this version is called in the dtor removing parameters
  // from the global registry must be handled separately.
  for ( std::vector<Parameter*>::iterator c = m_parameterSet.begin(); 
            c != m_parameterSet.end(); ++c )
  {
          delete *c;
  }
  //## end ComponentBase::deleteParameters%3DD11CE00221.body
}

void ComponentBase::registerParameters () const
{
  //## begin ComponentBase::registerParameters%3A9EA6A101BB.body preserve=yes
  std::vector<Parameter*>::const_iterator r = m_parameterSet.begin();
  std::vector<Parameter*>::const_iterator rEnd = m_parameterSet.end();
  int Index = index();  
  const string& componentName = name();
  const string& modelName = parentName();
  while ( r != rEnd )
  {
        std::ostringstream key;
        // the Index is the component index in the current model, used to
        // ensure the parameter key is unique for a given model.
        key << modelName << ':' << componentName << '[' << Index << "]:" << (*r)->name(); 
        XSContainer::models->addParameterToList(key.str(),*r);  
        ++r;       
  }  
  //## end ComponentBase::registerParameters%3A9EA6A101BB.body
}

size_t ComponentBase::parameterIndexBase () const
{
  //## begin ComponentBase::parameterIndexBase%3AA3FB7F028F.body preserve=yes
  //## end ComponentBase::parameterIndexBase%3AA3FB7F028F.body

  return m_parent->parameterIndexBase();
}

void ComponentBase::reindexParameters (int parameterOffset)
{
  //## begin ComponentBase::reindexParameters%3AA40DB10198.body preserve=yes
  std::vector<Parameter*>::iterator r = m_parameterSet.begin();
  std::vector<Parameter*>::iterator rEnd = m_parameterSet.end();
  while ( r != rEnd )
  {
          (*r)->reindex(parameterOffset);
          ++r;
  }  
  //## end ComponentBase::reindexParameters%3AA40DB10198.body
}

Parameter* ComponentBase::parameter (const string& paramName) const
{
  //## begin ComponentBase::parameter%3C6D3D4A03DE.body preserve=yes
  std::vector<Parameter*>::const_iterator r = m_parameterSet.begin();
  std::vector<Parameter*>::const_iterator rEnd = m_parameterSet.end();

  Parameter* found = 0;
  
  while ( !found && r != rEnd )
  {
          if ( (*r)->name() == paramName )
          {
                  found = *r;
          }
          ++r;       
  }
  return found;   
  //## end ComponentBase::parameter%3C6D3D4A03DE.body
}

size_t ComponentBase::incrementModelParameterCount ()
{
  //## begin ComponentBase::incrementModelParameterCount%3AA5580B00B3.body preserve=yes
  //## end ComponentBase::incrementModelParameterCount%3AA5580B00B3.body

  return m_parent->incrementModelParameterCount();
}

size_t ComponentBase::incrementModelComponentCount ()
{
  //## begin ComponentBase::incrementModelComponentCount%3AA558B5036E.body preserve=yes
  //## end ComponentBase::incrementModelComponentCount%3AA558B5036E.body

  return m_parent->incrementModelComponentCount();
}

size_t ComponentBase::modelIndex () const
{
  //## begin ComponentBase::modelIndex%3AA6969F0358.body preserve=yes
  //## end ComponentBase::modelIndex%3AA6969F0358.body

  return m_parent->modelIndex();
}

Parameter* ComponentBase::getLocalParameter (size_t i) const
{
  //## begin ComponentBase::getLocalParameter%3AA92D860166.body preserve=yes
  //## end ComponentBase::getLocalParameter%3AA92D860166.body

  return m_parent->getLocalParameter(i);
}

Parameter* ComponentBase::localParameter (size_t i) const
{
  //## begin ComponentBase::localParameter%3AA9373000E1.body preserve=yes
  std::vector<Parameter*>::const_iterator vp = m_parameterSet.begin();
  std::vector<Parameter*>::const_iterator vpEnd = m_parameterSet.end();
  Parameter* result(0);
  
  while ( vp != vpEnd )
  {
          if ((*vp)->index() == i) 
          {
                  result = *vp;
                  break;
          }
          ++vp;
  }
  
  return result;  
  //## end ComponentBase::localParameter%3AA9373000E1.body
}

size_t& ComponentBase::numParams ()
{
  //## begin ComponentBase::numParams%3B9790F300E1.body preserve=yes
  //## end ComponentBase::numParams%3B9790F300E1.body

  return m_numParams;
}

void ComponentBase::linkParametersToPrimary ()
{
  //## begin ComponentBase::linkParametersToPrimary%3AB2396203A8.body preserve=yes
  std::vector<Parameter*>::iterator i(m_parameterSet.begin());
  std::vector<Parameter*>::iterator iEnd(m_parameterSet.end());
  int base(parameterIndexBase());   
  while (i != iEnd )
  {
        std::ostringstream linkString;
	string modelName = m_parent->parent()->name();
        linkString << "=  ";
        int linkTo  = (*i)->index() - base;
        linkString << modelName << ":" << linkTo ;
        (*i)->modify(linkString.str());
        ++i;       
  }        
  //## end ComponentBase::linkParametersToPrimary%3AB2396203A8.body
}

const ArrayContainer& ComponentBase::getEnergyArray () const
{
  //## begin ComponentBase::getEnergyArray%3AD31FCE02AA.body preserve=yes
  //## end ComponentBase::getEnergyArray%3AD31FCE02AA.body

  return m_parent->energyArray();
}

size_t ComponentBase::modfileLocation () const
{
  //## begin ComponentBase::modfileLocation%3C0CE9F501A0.body preserve=yes
  ComponentInfo n (XSModelFunction::fullMatch(m_name));
  return n.location;  
  //## end ComponentBase::modfileLocation%3C0CE9F501A0.body
}

string ComponentBase::modfileSource () const
{
  //## begin ComponentBase::modfileSource%3C0CEA04012D.body preserve=yes
  ComponentInfo n (XSModelFunction::fullMatch(m_name));
  return n.sourceFile;     
  //## end ComponentBase::modfileSource%3C0CEA04012D.body
}

void ComponentBase::clearArrays (const std::set<UniqueEnergy*>& currentEngs)
{
  //## begin ComponentBase::clearArrays%3C7670E30175.body preserve=yes
  UniquePhotonContainer::iterator d (m_uniquePhotonArray.begin());
  UniquePhotonContainer::iterator dEnd (m_uniquePhotonArray.end());
  
  while  (d != dEnd)
  {
     // I really don't like doing this const_cast, but
     // it's only to allow d->first to be used as a key.
     // It doesn't actually modify what doomed points to.
     UniqueEnergy* doomed = const_cast<UniqueEnergy*>(d->first);
     if (currentEngs.find(doomed) == currentEngs.end())
     {
        m_uniquePhotonArray.erase(d++);  
        UniquePhotonContainer::iterator itErr = 
                m_uniquePhotonErrArray.find(doomed);
        if (itErr != m_uniquePhotonErrArray.end())
           m_uniquePhotonErrArray.erase(itErr);     
     }
     else ++d;
  }
  //## end ComponentBase::clearArrays%3C7670E30175.body
}

std::vector<ModParam*> ComponentBase::getVariableParameters () const
{
  //## begin ComponentBase::getVariableParameters%3C7BA9530037.body preserve=yes
  std::vector<Parameter*>::const_iterator ps = m_parameterSet.begin();        
  std::vector<Parameter*>::const_iterator psEnd = m_parameterSet.end(); 
  
  std::vector<ModParam*> vp;
  vp.reserve(m_parameterSet.size());
  while (ps != psEnd)
  {
          ModParam* t = dynamic_cast<ModParam*>(*ps);
          if (t)
          {
                if ( !t->isFrozen() && !t->isLinked()) vp.push_back(t);       
          }
          ++ps;       
  }       
  return vp;
  //## end ComponentBase::getVariableParameters%3C7BA9530037.body
}

std::vector<Parameter*> ComponentBase::cloneParameters (ComponentBase* newParent) const
{
  //## begin ComponentBase::cloneParameters%3DD11C470041.body preserve=yes
  size_t N(m_parameterSet.size());
  std::vector<Parameter*> clonedParameterSet(N,0);
  for ( size_t j = 0; j <  N; ++j )
  {
        clonedParameterSet[j] = m_parameterSet[j]->clone(newParent);
  }  
  return clonedParameterSet;
  //## end ComponentBase::cloneParameters%3DD11C470041.body
}

int ComponentBase::resequenceParameters (int startValue)
{
  //## begin ComponentBase::resequenceParameters%3F0C5FF901A7.body preserve=yes
        
  // resequence parameters in this component and return the last 
  // index number allocated.      
  int N(m_parameterSet.size());
  int newIndex(startValue);
  for (int i = 0  ; i < N; ++i, ++newIndex) 
  {
          m_parameterSet[i]->index(newIndex);  
  }  
  return newIndex;
  //## end ComponentBase::resequenceParameters%3F0C5FF901A7.body
}

void ComponentBase::deregisterParameters () const
{
  //## begin ComponentBase::deregisterParameters%3F2980050068.body preserve=yes
  std::vector<Parameter*>::const_iterator r = m_parameterSet.begin();
  std::vector<Parameter*>::const_iterator rEnd = m_parameterSet.end();
  int Index = modelIndex();  
  while ( r != rEnd )
  { 
        XSContainer::models->deregisterParameter((*r)->index(),Index);          
        ++r;       
  }   
  //## end ComponentBase::deregisterParameters%3F2980050068.body
}

const std::set<UniqueEnergy*>& ComponentBase::getUniqueEnergies () const
{
  //## begin ComponentBase::getUniqueEnergies%43D650DF00EE.body preserve=yes
   return m_parent->uniqueEnergyArray();
  //## end ComponentBase::getUniqueEnergies%43D650DF00EE.body
}

//## Get and Set Operations for Class Attributes (implementation)

void ComponentBase::compute (bool value)
{
  //## begin ComponentBase::compute%3C20E0DD0057.set preserve=yes
  m_compute = value;
  //## end ComponentBase::compute%3C20E0DD0057.set
}

//## Get and Set Operations for Associations (implementation)

void ComponentBase::parameterSet (const std::vector<Parameter*>& value)
{
  //## begin ComponentBase::parameterSet%3A8ADC0100A1.set preserve=no
  m_parameterSet = value;
  //## end ComponentBase::parameterSet%3A8ADC0100A1.set
}

void ComponentBase::parameterSet (size_t index, Parameter* value)
{
  //## begin ComponentBase::parameterSet%3A8ADC0100A1.qualset preserve=no
  m_parameterSet[index] = value;
  //## end ComponentBase::parameterSet%3A8ADC0100A1.qualset
}

RealArray& ComponentBase::uniquePhotonArray (const UniqueEnergy* uniqueEnergy)
{
  //## begin ComponentBase::uniquePhotonArray%43D6A8280155.qualget preserve=no
  return m_uniquePhotonArray[uniqueEnergy];
  //## end ComponentBase::uniquePhotonArray%43D6A8280155.qualget
}

RealArray& ComponentBase::uniquePhotonErrArray (const UniqueEnergy* uniqueEnergy)
{
  //## begin ComponentBase::uniquePhotonErrArray%43D6AE450209.qualget preserve=no
  return m_uniquePhotonErrArray[uniqueEnergy];
  //## end ComponentBase::uniquePhotonErrArray%43D6AE450209.qualget
}

RealArray& ComponentBase::savedUniquePhotonArray (const UniqueEnergy* uniqueEnergy)
{
  //## begin ComponentBase::savedUniquePhotonArray%43D6B00F032F.qualget preserve=no
  return m_savedUniquePhotonArray[uniqueEnergy];
  //## end ComponentBase::savedUniquePhotonArray%43D6B00F032F.qualget
}

// Additional Declarations
  //## begin ComponentBase%3A8AD229032B.declarations preserve=yes
  //## end ComponentBase%3A8AD229032B.declarations

//## begin module%3A8AD2F6035D.epilog preserve=yes
//## end module%3A8AD2F6035D.epilog
